
require 'librefe'


def main
  t = nil
  File.open( ARGV[0] || 'manual.rd' ) do |f|
    t = create_index(f)
  end
  File.open( Refe::INDEX_FILE, 'w' ) do |f|
    Marshal.dump t, f
  end
end

def create_index( f )
  table = {}
  s_table = {}
  klass = nil
  buf = s = nil

  f.each do |line|
    case line
    when /\A= ([A-Z]\w+(?:::[A-Z]\w+)*)\s*\z/
      klass = $1
      buf = nil
    when /\A= /
      klass = buf = nil
    when /\A=+ 饹᥽å/e,
         /\A=+ ⥸塼ؿ/e
      s = true
      buf = nil
    when /\A=+ ᥽å/e
      s = false
      buf = nil
    when /\A=+/
      buf = nil
    when /\A: /
      if klass then
        n = getmname(line) and
            ((s ? s_table : table)[klass] ||= {})[n] = buf = line
      end
    else
      buf << line if buf
    end
  end

  Refe.new( table, s_table )
end

METHOD_RE = [
  [/\A:\s*(\w+[?!]?)\s*(?:[\(\{]|\z)/    , ''   ],# name(arg), name { }, name
 #[/\A:\s*(\w+[?!]?)\s*\z/               , ''   ],# name
 #[/\A:\s*(\w+[?!]?)\s*\{/               , ''   ],#
  [/\A:\s*(\w+)\s*\=/                    , '='  ],# name =
  [/\A:\s*\w+\[.*\]=/                    , '[]='],# self[key]=
  [/\A:\s*\w+\[.*\]/                     , '[]' ],# self[key]
  [/\A:\s*self\s*([+-<>=~*^&|%]+)\s*\w+/ , ''   ],# self + other
  [/\A:\s*([+\-~])\s*\w+/                , ''   ] # ~ self
]

def getmname( line )
  i = getmname_(line)
  printf "%15s %s\n", i.inspect, line.strip if $DEBUG and not i
  i
end

def getmname_( line )
  METHOD_RE.each do |re,s|
    if m = re.match(line) then
      return case s.size
             when 0 then m[1]
             when 1 then m[1] + s
             else        s
             end
    end
  end
  nil
end


main
